<?php
	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

	//require_once( dirname(__FILE__) . "/app.php.inc" );
	require_once( dirname(__FILE__) . "/manager.util.php.inc" );
	
	require_once( dirname(__FILE__) . "/manager.base.php.inc" );

	/* --------------------------------------------------------------------
	 * ƥϹܥ饹
	 * 
	 */ 
	class TextEntryItem extends BaseEntryItem
	{
		var $maxLength = 0;
		var $minLength = 0;
		var $output = '';
		var $rows = 0;
		var $cols = 0;
		var $size = 0;
		
		/* ----------------------------------------------------------------
		 * 󥹥ȥ饯
		 * $xmlSchemaData : б륹DataXMLǡ
		 */
		function TextEntryItem( $xmlSchemaData, $entryName, $entryId  )
		{
			// ١󥹥ȥ饯θƤӽФ
			parent::BaseEntryItem( $xmlSchemaData, $entryName, $entryId  );
		
			$this->output= $xmlSchemaData->get_attribute('output');
			if ( empty( $this->output ) )
			{
				$this->output = "text1";		// ǥե
			}
			else
			{
				switch ( $this->output )
				{
					case 'text1' :
					case 'text2' :
					case 'html1' :
					case 'html2' :
						break;
					
					default :
						cmsd_abort_proc( "޹顼'" . $this->dataName . "'output°'" . $this->output . "'ꤵƤޤ" );
				}
			}
			
			$rows = $xmlSchemaData->get_attribute('rows');
			if ( !empty( $rows ) && is_numeric( $rows ) )
			{
				$this->rows = $rows;
			}
			
			$cols = $xmlSchemaData->get_attribute('cols');
			if ( !empty( $cols ) && is_numeric( $cols ) )
			{
				$this->cols = $cols;
			}
			
			$size = $xmlSchemaData->get_attribute('size');
			if ( !empty( $size ) && is_numeric( $size ) )
			{
				$this->size = $size;
			}
			
			$maxlength = $xmlSchemaData->get_attribute('maxlength');
			if ( !empty( $maxlength ) && is_numeric( $maxlength ) )
			{
				$this->maxLength = $maxlength;
			}
			
			$minlength = $xmlSchemaData->get_attribute('minlength');
			if ( !empty( $minlength ) && is_numeric( $minlength ) )
			{
				$this->minLength = $minlength;
			}
			
			
			
		}
		
		/* ----------------------------------------------------------------
		 * ܤXMLΡɤ򿷵롣
		 * $xmlDocParentEntry : ȥDOM֥ȡ
		 * return : XMLΡɡ
		 */
		function createNew( $xmlDocParentEntry )
		{
   			$newNode = parent::createNew( $xmlDocParentEntry );
			$newNode->set_attribute( 'output', $this->output );
			
			return $newNode;
		}		
		
		/* ----------------------------------------------------------------
		 * Ƥǥȥܤ򹹿롣
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
		function update( $xpathEntry, $currentEntry )
		{
			// ȥXML
			$xmlEntryDataList = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
			$xmlEntryData = $xmlEntryDataList->nodeset[0];

			// "name"°бPOST¸ߤСȥȿǤ롣
			if ( isset( $_POST[ $this->dataName ] ) )
			{
				$datavalue = $_POST[ $this->dataName ];
				
				//print( "get_magic_quotes_gpc() = '" . get_magic_quotes_gpc() . "'<br />\n" );
				
				// ֥륯Ȥȥ󥰥륯Ȥμư׽ONˤʤäƤ顦
				if ( get_magic_quotes_gpc() )
				{
					// פ򸵤᤹
					$datavalue = stripslashes( $datavalue );
				}
				
				// ĹåʺĹ
				if ( ( $this->maxLength > 0 ) and ( mb_strlen( $datavalue) > $this->maxLength ) )
				{
					$this->errorMessage = sprintf( "%s  %d ʸĶޤ", $this->dataCaption, $this->maxLength );
					return false;
				}
				
				// ĹåʺǾĹ
				if ( mb_strlen( $datavalue) < $this->minLength )
				{
					$this->errorMessage = sprintf( "%s  %d ʸʾϤɬפǤ", $this->dataCaption, $this->minLength );
					return false;
				}
				
				// ޤƥȥΡɤʺʤȡset_contentǤϥƥȥΡɤˡ
				$xmlEntryData = $xmlEntryDataList->nodeset[0];
				EntryUtil::deleteTextNode( $xmlEntryData );
				
				// ƥȥΡɤ˿ͤset롣
				$xmlEntryData->set_content( fileconv( $datavalue ) );
				//print( $dataname . " = " . htmlconv( $datavalue ) . "<br>\n" );
				//print( $this->dataName . " : " . htmlconv( $datavalue ) . "<br>\n" );
				//print( $this->dataName . " = " . htmlconv( $xmlEntryData->get_content() ) . "<br>\n" );
				
				// output°ǿΥޤͤǹ롣
 		   		$xmlEntryData->set_attribute( 'output', $this->output );
				
			}
			
			return true;
		
		}
		
		/* ----------------------------------------------------------------
		 * եܤ褹HTML֤
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
		function renderFormItem( $xpathEntry, $currentEntry )
		{
			$xmlEntryDataArray = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
			$value = $xmlEntryDataArray->nodeset[0]->get_content();
			
			$strFormHTML = '';
			
			switch ( $this->dataType )
			{
				case 'textarea' :
					$strFormHTML .= $this->renderFormItemTEXTAREA( $value );
					break;
				
				case 'text' :
					$strFormHTML .= $this->renderFormItemTEXT( $value );
					break;
			}
			
			return $strFormHTML;
		}
		
		/* ----------------------------------------------------------------
		 * եܤ褹HTML֤TEXTAREAˡ
		 * $value : ͡
		 */
		function renderFormItemTEXTAREA( $value )
		{
		
			if ( $this->rows == 0 && $this->cols == 0 )
			{
				// ƥȥܥåιԿĴ롣
				$cols = 75;
				if ( $this->maxLength > 0 )
				{
					$rows = intval(( $this->maxLength / ( $cols / 2 ) ) + 1);
				}
				else
				{
					$rows = 3;
				}
			}
			else
			{
				// ޤ˻ꤵ줿ͤTEXTAREAɽ롣
				$cols = $this->cols;
				$rows = $this->rows;
			}
		
			$strFormHTML = '';
			$strFormHTML .= '<textarea cols="' . $cols .  '" rows="' . $rows . '" name="' . $this->dataName . '" >' . htmlconv( $value ) . '</textarea><br>' . "\n";

			return $strFormHTML;
		}
		
		
		/* ----------------------------------------------------------------
		 * եܤ褹HTML֤TEXTAREAˡ
		 * $value : ͡
		 */
		function renderFormItemTEXT( $value )
		{
			if ( $this->size == 0 )
			{
			
				if ( $this->maxLength > 0 and $this->maxLength < 35 )
				{
					// sizeʸĹ3ܤˤ롣sizeʸ1/3餤Ĺˤɽʤ
					$size = $this->maxLength * 3;
				}
				else
				{
					// Ĺ¤0ޤ35ʾʤ顢ƥȥܥå100Ȥ롣
					$size = 100;
				}
			}
			else
			{
				$size = $this->size;
			}
			
			
			$strFormHTML = '';
			
			if ( $this->maxLength > 0 )
			{
				// maxlength°ꤹ롣
				$strFormHTML .= '<input type="text" size="' . $size . '" maxlength="' . $this->maxLength .  '" name="' . $this->dataName . '" value="' . htmlconv( $value ) . '" /><br>' . "\n";
			}
			else
			{
				// maxlength°ꤷʤ
				$strFormHTML .= '<input type="text" size="' . $size . '" name="' . $this->dataName . '" value="' . htmlconv( $value ) . '" /><br>' . "\n";
			
			}
			
			return $strFormHTML;

		}
		
		/* ----------------------------------------------------------------
		 * եܤ褹HTML֤
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
		function renderFormItemXML( $xpathEntry, $currentEntry, &$xmlOutputEntryData )
		{
			$xmlEntryDataArray = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
			$value = $xmlEntryDataArray->nodeset[0]->get_content();
			
			switch ( $this->dataType )
			{
				case 'textarea' :
					if ( $this->rows == 0 && $this->cols == 0 )
					{
						// ƥȥܥåιԿĴ롣
						$cols = 75;
						if ( $this->maxLength > 0 )
						{
							$rows = (int)(( $this->maxLength / ( $cols / 2 ) ) + 1);
						}
						else
						{
							$rows = 3;
						}
					}
					else
					{
						// ޤͤɤ߹ࡣ
						$cols = $this->cols;
						$rows = $this->rows;
					}
					
					$xmlOutputEntryData->set_attribute('rows', $rows );
					$xmlOutputEntryData->set_attribute('cols', $cols );
					$xmlOutputEntryData->set_attribute('output', $this->output );
					
					// ꥯȤͤСͤɽʥ顼ͤݾڤ褦ˤ
					if ( isset( $_POST[ $this->dataName ] ) )
					{
						$value = $_POST[ $this->dataName ];
						
						// ֥륯Ȥȥ󥰥륯Ȥμư׽ONˤʤäƤ顦
						if ( get_magic_quotes_gpc() )
						{
							// פ򸵤᤹
							$value = stripslashes( $value );
						}
						
						$value = fileconv( $value );
						$xmlOutputEntryData->set_content( $value);	// fileconvλǴhtmlspecialcharsѡ				
					}
					else
					{
						$xmlOutputEntryData->set_content( htmlspecialchars( $value, ENT_QUOTES ) );						
					}

				
					break;
				
				case 'text' :
					if ( $this->size == 0 )
					{
						if ( $this->maxLength > 0 and $this->maxLength < 35 )
						{
							// sizeʸĹ3ܤˤ롣sizeʸ1/3餤Ĺˤɽʤ
							$size = $this->maxLength * 3;
						}
						else
						{
							// Ĺ¤0ޤ35ʾʤ顢ƥȥܥå100Ȥ롣
							$size = 100;
						}
					}
					else
					{
						$size = $this->size;
					}	
					
					$xmlOutputEntryData->set_attribute('size', $size );
					if ( $this->maxLength > 0 )
					{
						$xmlOutputEntryData->set_attribute('maxlength', $this->maxLength );
					}
					
					// ꥯȤͤСͤɽʥ顼ͤݾڤ褦ˤ
					if ( isset( $_POST[ $this->dataName ] ) )
					{
						$value = $_POST[ $this->dataName ];
						
						// ֥륯Ȥȥ󥰥륯Ȥμư׽ONˤʤäƤ顦
						if ( get_magic_quotes_gpc() )
						{
							// פ򸵤᤹
							$value = stripslashes( $value );
						}
						
						$value = fileconv( $value );
						$xmlOutputEntryData->set_content( $value ); // fileconvλǴhtmlspecialcharsѡ	
					}
					else
					{
						$xmlOutputEntryData->set_content( htmlspecialchars( $value, ENT_QUOTES ) );
					}
					
				
					break;
			}
			
		}
		
	
	}

?>